;obscura
;sensenstahl
;www.sensenstahl.com
;fasm 1.69.31
;listening: vollmondprozession - lazarus

;16 colors (gray scale part of the standard palette)
;tested under different builds of the box, xp and freedos

org 100h
use16

;assuming:
;ax = bx = cx = 255

start:   push 0a000h     ;vga
         pop es

         mov al,13h      ;320x200x256
         int 10h

         push 08000h
         pop ds          ;buff the stuff

         mov fs,bx       ;timer for vsync

;create the sizes of the squares
init:
inc ax   ;init size values for squares
         ;so it is identical each run
mul bx   ;rnd enough
shr al,3 ;that as well, so there is a nice
         ;distribution
mov byte[cs:sze+bx],al ;save the size
inc bx
loop init ;convenient!

jmp flip ;invest 3 bytes into a clean start
         ;because the buffer can have any values
         ;at the beginning which results in
         ;a colourful hickup at the 1st loop
         ;at the glass bar generation
         ;and instead of adding another line or
         ;some useless thing the bytes are better
         ;used this way
         ;to avoid this vsync + flip could be moved
         ;just below main: which would save the jmp
         ;but it would introduce a bug due to ax
         ;not being the same value when the routine
         ;for creating the squares starts. so 0ing
         ;ax would eat the saved bytes (and dec ax
         ;would have to be changed to dec al at the
         ;key check. so there is nothing to save

main:

;make squares/rectangles with random
;distribution and parallax movement
;cx = 0 always
;ax is also identical here each run

dec cl ;those are enough
f1:
mov di,bp  ;grab global movement

inc ax ;rnd
mul cx ;enough
;mov di,ax ;save pos
;cmp al,127 ;parallax?
jp nah     ;nah
;add di,bp  ;ja!
shl di,1
nah:

;cmp dh,0
;jne breaker ;confirmer for testing
             ;and it confirmed

mov bx,cx ;indexing the size value
;movzx dx,byte[cs:sze+bx] ;get size value
                         ;dh = ? due to mul above
mov dl,byte[cs:sze+bx] ;get size value
                       ;byte works because it
                       ;got confirmed

inc dx    ;change value for size
cmp dx,30 ;reached max?
jnae k    ;not yet
mov dl,1  ;yep, so reset but avoid danger 0!
k:
mov byte[cs:sze+bx],dl ;save new value

cmp dx,15 ;size change?
jb k2     ;no, please keep growing
neg dx    ;invert
add dx,30 ;size change so it shrinks and fades
k2:

;imul si,dx,320
mov si,dx ;y part; only usable register at this point :)
inc dx ;x +1 ;so they are a bit more like squares
             ;at least when the pixels are adjusted
             ;so they are not squares
two:
mov ch,dl ;copy size for x direction
one:
mov bx,dx ;get size
shr bx,1  ;half the size
imul bx,-321 ;calc center of object
             ;so it moves correctly
;sub bx,di ;movement/parallax
sub bx,ax ;random pos

add dl,15 ;color 16-31
          ;only add 15 because of the +1 of x(color) above
mov byte[ds:bx+di],dl
;mov byte[ds:bx-321],dh;0

sub dl,15 ;reset so  nothing gets fucked up
inc di ;x part
dec ch ;do whole length of x axis
jnz one
sub di,dx ;reset x part to 0

mov bx,320 ;save some b below

add di,bx;320
;sub si,bx;320
dec si
jnz two ;y part

loop f1 ;create them all


;creating the movement of the taditional glass bar
mov si,word[cs:start] ;get value

mov ax,319 ;save a few bytes below

inc si;dec si;inc si ;change
cmp si,bx;320        ;max?
jnae k3              ;not yet
xor si,si;mov si,ax;xor si,si  ;reset
k3:
mov word[cs:start],si ;store and use si below directly

;inc bx
sub bp,322;bx;321 ;bring the global player into the game

;mov si,ax;si ;y
;add the glassbar with squares getting insometric-ish
scanner2:
mov dl,127 ;x
scanner1:
;xor dh,dh
movzx bx,dl ;get x for use
;add bx,si
;add bx,ax ;movement is already included in si
;mov cl,byte[ds:bx+si]
;cmp cl,16
;jbe nonono
;cmp cl,ch;0
;je nonono

;add cl,byte[ds:bx+si] ;cl = 0 here, always!
;jz nonono
mov cl,byte[ds:bx+si] ;when bg color is 16 (set at flip)

sub cl,15 ;calculate steps to draw based on grayscale

;mov al,cl
mov dh,16 ;color to start drawing with
upgrade:
mov byte[ds:bx+si],dh ;draw
sub bx,ax;319         ;move drawing pos
inc dh                ;change color
loop upgrade          ;draw whole range

nonono:
dec dl                ;x
jnz scanner1

add si,ax;319         ;y
jnc scanner2          ;do the whole glassbar


;make top and bottom fade to black
;which makes some smooth pal bars along the way
inc ax;=320
mov dl,40     ;for changing color
              ;equals steps for y change
mov di,320*40 ;y, height of fader/pal bar
dark1:
mov cl,2 ;make 2 runs, 1st bottom, then top
again2:
mov bx,ax;320 ;x
dark2:
mov dh,byte[ds:di+bx+320*159-1] ;get pixel
;cmp dh,ch;0

;je nononono ;if 0 so skip but that is not needed since bg = 16
cmp dl,16    ;do not sub more than 16 (31-16 max)
ja nononono2
sub dh,dl    ;sub
cmp dh,16    ;min value
jae k5       ;above, so ok
nononono2:
mov dh,16    ;if below set min value
k5:          ;keeping range of 16..31
mov byte[ds:di+bx+320*159-1],dh ;set new pixel

nononono:

dec bx          ;x
jnz dark2
neg di              ;prepare for making the top at 2nd run
sub di,320*120;119  ;normalizes di again after 2nd loop
                    ;so there is no issue in the next run
loop again2         ;repeat 1 time

dec dl              ;for changing color
sub di,ax;320       ;do complete height
jnz dark1           ;of the fader bars


;put a black edge on the glass bar, because why not
;save 2b by putting it here instead of right after the
;glassbar because there it would need to be color 16 to avoid
;color override at the fader routine 
dec ax ;319
brrk:
mov word[ds:si-50],cx     ;i know this is cheating because that
mov word[ds:si-50-128],cx ;makes it 17 color values. but still
add si,ax                 ;only 16 grayscale colors so matlock
jnc brrk                  ;can't put me in jail

;vsync
mov ax,word[fs:046ch] ;get timer
again:
cmp word[fs:046ch],ax ;check if changed
je again              ;no so check again

;mov di,320*19
;mov cx,320*160
flip:
mov ax,16           ;black, this eliminates checks
                    ;for 0 at different areas of the code
xchg al,byte[ds:di] ;grab buffer
;cmp al,31
;jne ko
;mov al,67          ;this adds nothing useful tho
;ko:
stosb               ;drop + inc di
loop flip

         in al,60h            ;read keyboard buffer
         dec ax               ;ah=0
         jnz main             ;no, so go on
breaker: ret                  ;halt!
filler: db 219,178,177,176    ;i was happy with it and still
                              ;got those bytes squeezed out
                              ;but there is nothing useful for
                              ;them to do ... so let's
                              ;fade out the binary ;)
sze db ?                      ;space for generated sizes
                              ;for the individual squares